module Coder where

import Lexer
import Instruction

codingError = error . ("coding error: " ++)

coding ((address, machineCodes@(m:ms), ins@(OperandString1 ".ALIGN" _), comment):is) =
    codingAddress address ++ ":\t" ++
    codingMachineCodes (fst sp) ++ "\t" ++
    (if (snd sp) == []
     then codingMnemonic (ins, comment) ++ "\n" ++ coding is
     else "\t\t\t\n" ++ coding ((address + length (fst sp), (snd sp), ins, comment):is)
    )
    where
      sp = splitAt 2 machineCodes

coding (i@(address, machineCodes, ins, comment):is) =
    codingAddress address ++ ":\t" ++
    codingMachineCodes machineCodes ++ "\t" ++
    codingMnemonic (ins, comment) ++ "\n" ++
    case is of
      [] -> codingAddress (address + length machineCodes) ++ ":" ++ "\t\t\t" ++codingComment "generated by gmc4cc (terus)" ++ "\n"
      _ -> coding is
coding [] = "" 

codingMnemonic (ins, comment) =
    case ins of
      i@(Label _) -> show i ++ "\t" ++ codingComment comment
      i -> "\t" ++ show i ++ codingComment comment

codingAddress = hexString 2

codingMachineCodes = unwords . map hexChar

codingComment "" = ""
codingComment s = "\t\t# " ++ s

codingFxp = ("<?xml version=\"1.0\"?>\n<ArrayOfString xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\n" ++) . 
            (++"</ArrayOfString>\n") .
            (codingFxpInstructions 0x60) 
codingFxpInstructions n ((address, machineCodes, ins, comment):is) =
    concat (map (("  <string>"++).(++"</string>\n").hexChar) machineCodes) ++ codingFxpInstructions (n - length machineCodes) is
codingFxpInstructions n [] | n <= 0 = "" 
codingFxpInstructions n [] = "  <string>F</string>\n" ++ codingFxpInstructions (n - 1) []
