import System

import Lexer
import Parser
import Emitter
import Optimizer
import Assembler
import Coder

import AssemblyParser

main = do
  args <- getArgs
  do let 
      checkArgs x = any (== x) args

      macheCodesOptimizeJob = if checkArgs "-O0" then macheCodesRequiredOptimize else macheCodesOptimize
      treeOptimizeJob = if checkArgs "-O0" then id else treeOptimize

      codingJob = if checkArgs "--fxp" then codingFxp else coding

      compile = codingJob . assemble . macheCodesOptimizeJob . emit . treeOptimizeJob . parse . lexer

      job = if checkArgs "--assemblerinput" then codingJob . assemble . macheCodesOptimizeJob . assemblyParse
            else if checkArgs "--lexonly" then unlines . map show . lexer
                 else if checkArgs "--parseonly" then show . treeOptimizeJob . parse . lexer
                      else if checkArgs "--blockonly" then
                               showBlocks .
                               (if checkArgs "-O0" then id else optimizeBlocks) . 
                               splitBlocks . emit . treeOptimizeJob . parse . lexer
                           else compile
      in
        putStr . job =<< getContents
